/********************************************************************
  BasicDSP
  Copyright 2006-2007 
  Pieter-Tjerk de Boer PA3FWM pa3fwm@amsat.org
  Niels Moseley PE1OIT n.a.moseley@alumnus.utwente.nl
  License: GPLv2
********************************************************************/

#ifndef displayslider_h
#define displayslider_h


// a class combines a wxSlider and a wxEditbox
class DisplaySlider : public wxFrame
{
public:
  DisplaySlider(wxWindow *parent, wxSizer *parentsizer, const wxString &title, wxWindowID sliderID, 
    float value, float slidermin, float slidermax, const wxString& format, int bordersize = 0);
  virtual ~DisplaySlider();

  bool Hide(); // returns true if the control was not hidden already
  bool Show(); // returns true if the control was not shown already 

  bool HasChanged();

  void  SetValue(float val);
  float GetValue();

  void SetSliderMin(float v) { vmin = v; };
  void SetSliderMax(float v) { vmax = v; };
  void UpdateDisplay();

  void SetMinTitleWidth(int width);
  int  GetTitleWidth() const;
  
protected:
  bool        hasChanged;
  wxWindow    *myparent;
  wxSizer     *parentsizer;
  wxWindowID  slider_ID;
  wxSlider    *slider;
  wxString    displaytext;
  wxString    formatstring;
  wxTextCtrl  *text;
  float vmin,vmax;
  bool        isHidden;
  wxBoxSizer  *hsizer;
  wxStaticText *title;


  void OnSlider(wxScrollEvent& event);
  void OnSliderText(wxCommandEvent& event);
};

DECLARE_EVENT_TYPE(wxEVT_COMMAND_DISPLAYSLIDER_EVENT, -1)

#endif
