/********************************************************************
  BasicDSP
  Copyright 2006-2007 
  Pieter-Tjerk de Boer PA3FWM pa3fwm@amsat.org
  Niels Moseley PE1OIT n.a.moseley@alumnus.utwente.nl
  License: GPLv2
********************************************************************/

#ifndef _graphframe_h
#define _graphframe_h

#include <vector>
#include "wx/wx.h" 

#include "spectrumplot.h" 

class MyGraphFrame; //pre-declaration


/** The baseclass for an object that is called when a MyGraphFrame closes */ 
class GraphFrameCloseReceiver
{
public:
  virtual void GFrameCloseNotify(MyGraphFrame *isClosing) = 0;
};


/** MyGraphFrame a window that holds a plotting surface. */
class MyGraphFrame : public wxFrame
{
public:
	MyGraphFrame(wxFrame *parent, wxString title, wxArrayString checkboxnames, const wxString &xf, const wxString &xfk, GraphFrameCloseReceiver *closereceiver = NULL);
	virtual ~MyGraphFrame();

	void SetMinMax(float dbmi, float dbma, float fmi, float fma, float xz=1.0);
	void SetLevel(float *l , float *r);

	bool check(int i) const { return checkboxes[i]->IsChecked(); };  // returns true if i'th checkbox has been selected
	wxString var_l() const { return varname_l->GetValue(); };        // returns variable name for 'left' channel
	wxString var_r() const { return varname_r->GetValue(); };        // returns variable name for 'right' channel

	void OnClose(wxCloseEvent& event);

	DECLARE_EVENT_TABLE()

private:
	wxFrame *myparent;
	wxSpectrumplot *specplot;
	std::vector<wxCheckBox*> checkboxes;
	wxTextCtrl *varname_l;
	wxTextCtrl *varname_r;
	GraphFrameCloseReceiver *closereceiver;
};

#endif
