wxString help_functions_html (
_T("<html><body>")
_T("<font size=-1>")
_T("<h2>Built-in functions</h2>")
_T("<table border='1'>")
_T("")
_T(" <tr><td>")
_T("abs(x)")
_T(" </td><td>")
_T("absolute value of x")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("biquad(x,a0,a1,a2,b0,b1,b2)")
_T(" </td><td>")
_T("biquad-filter applied to x with 6 coefficients; the transfer function is H(z) = (b0 + b1*z^-1 + b2*z^-2) / (a0 + a1*z^-1 + a2*z^-2)")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("biquad(x,g,a1,a2,b1,b2)")
_T(" </td><td>")
_T("biquad with 5 parameters: H(z) = g * (1 + b1*z^-1 + b2*z^-2) / (1 + a1*z^-1 + a2*z^-2)")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("cos(x)")
_T(" </td><td>")
_T("cosine of x, with x in radians")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("cos1(x)")
_T(" </td><td>")
_T("cosine of x, x=0...1 for a full circle")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("fir(x,a,b,c,...,j,k)")
_T(" </td><td>")
_T("x FIR-filtered with coefficients a,b,c,...,j,k")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("firsymeven(x,a,b,c,...,j,k)")
_T(" </td><td>")
_T("x FIR-filtered with coefficients a,b,c,...,j,k,k,j,....,c,b,a")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("firsymodd(x,a,b,c,...,j,k)")
_T(" </td><td>")
_T("x FIR-filtered with coefficients a,b,c,...,j,k,j,....,c,b,a")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("mod1(x)")
_T(" </td><td>")
_T("x mod 1; i.e., the fractional part of x")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("round(x,y)")
_T(" </td><td>")
_T("round x to nearest multiple of y")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("sin1(x)")
_T(" </td><td>")
_T("sine of x, x=0...1 for a full circle")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("sqrt(x)")
_T(" </td><td>")
_T("square root of x")
_T(" </td></tr>")
_T("")
_T("</table>")
_T("</font>")
_T("</body></html>")
);
wxString help_intro_html (
_T("<html>")
_T("<font size=-1>")
_T("BasicDSP is a program to apply simple Digital Signal Processing algorithms")
_T("to audio signals. The input can either be taken from the sound card, read")
_T("from a .WAV file, or be a locally generated sine wave or white noise.")
_T("The output is fed to the sound card, and its spectrum can be displayed.")
_T("")
_T("<p>")
_T("The DSP program is written in a very straightforward language which has")
_T("only assignment statements (and on Linux a print statement).")
_T("Each line contains one statement, and all lines are executed once for")
_T("each incoming sample. The input sample is available in variables named")
_T("'in', 'inl' (left channel) and 'inr' (right channel). The program should")
_T("write the output into variables named 'out', 'outl' and/or 'outr'.")
_T("<br>")
_T("Here's a simple example program:")
_T("")
_T("<br>")
_T("  a = a + slider1 * (in - a)")
_T("<br>")
_T("  outl = a")
_T("<br>")
_T("  outr = fir(in, 0.1, 0.3, 0.3, 0.1)")
_T("<br>")
_T("")
_T("<p>")
_T("This illustrates defining new variables ('a' in the example), the use of")
_T("the sliders, and the use of a built-in function like fir().")
_T("The help-menu gives access to a complete list of built-in variables and")
_T("functions.")
_T("</font>")
_T("</html>")
_T("")
);
wxString help_variables_html (
_T("<html><body>")
_T("<font size=-1>")
_T("<h2>Pre-defined variables</h2>")
_T("<table border='1'>")
_T("")
_T(" <tr><td>")
_T("in")
_T(" </td><td>")
_T("input sample, mono")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("inl")
_T(" </td><td>")
_T("input sample, left channel")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("inr")
_T(" </td><td>")
_T("input sample, right channel")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("out")
_T(" </td><td>")
_T("output sample, mono")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("outl, outi")
_T(" </td><td>")
_T("output sample, left (also I)")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("outr, outq")
_T(" </td><td>")
_T("output sample, right (also Q)")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("samplerate")
_T(" </td><td>")
_T("samplerate (in Hz)")
_T(" </td></tr>")
_T("")
_T(" <tr><td> slider1 </td><td> setting of Slider1 </td></tr>")
_T(" <tr><td> slider2 </td><td> setting of Slider2 </td></tr>")
_T(" <tr><td> slider3 </td><td> setting of Slider3 </td></tr>")
_T(" <tr><td> slider4 </td><td> setting of Slider4 </td></tr>")
_T("")
_T(" <tr><td>")
_T("uit")
_T(" </td><td>")
_T("output sample, mono")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("uitl, uiti")
_T(" </td><td>")
_T("output sample, left (also I)")
_T(" </td></tr>")
_T("")
_T(" <tr><td>")
_T("uitr, uitq")
_T(" </td><td>")
_T("output sample, right (also Q)")
_T(" </td></tr>")
_T("")
_T("</table>")
_T("</font>")
_T("</body></html>")
);
