/*

  cross platform Mutex & Friends
  Code by N.A. Moseley 12-08-2007

*/

#ifndef mutex_and_friends_h
#define mutex_and_friends_h

#ifndef WIN32
#include <pthread.h>
#else
#include <windows.h>
#endif

class MutexLocker;  // pre-declaration

class Mutex
{
friend MutexLocker;
public:
  Mutex();
  ~Mutex();

protected:
  void Lock();      // lock the mutex
  void Unlock();    // unlock the mutex

private:
#ifdef WIN32
  CRITICAL_SECTION cs;
#else
  pthread_mutex_t my_mutex;
#endif
};

class MutexLocker
{
public:
  MutexLocker(Mutex *m);
  ~MutexLocker();

private:
  Mutex *m;
};

#endif  //Sentry
