/********************************************************************
  BasicDSP
  Copyright 2006-2007 
  Pieter-Tjerk de Boer PA3FWM pa3fwm@amsat.org
  Niels Moseley PE1OIT n.a.moseley@alumnus.utwente.nl
  License: GPLv2
********************************************************************/

#ifndef __spectrumplot_h
#define __spectrumplot_h

#include "wx/wx.h"

class wxSpectrumplot : public wxControl
{
	DECLARE_DYNAMIC_CLASS(wxSpectrumplot)
	DECLARE_EVENT_TABLE()

public:
	virtual ~wxSpectrumplot();

	wxSpectrumplot() 
	{
		Init();
	};

	wxSpectrumplot(wxWindow *parent, wxWindowID id, 
		const wxString &label,
		const wxString &xf = _("%d"),
		const wxString &xfk = _("%d000"),
		const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize
		) 
	{
		Init();
		Create(parent, id, label, xf, xfk, pos, size);
	};

	bool Create(wxWindow *parent, wxWindowID id, 
		const wxString &label,
		const wxString &xf,
		const wxString &xfk,
		const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize);

	void Init() 
  { 
    n=1024;
		dbmin = -54;
		dbmax = 3;
    fmin = 0;
    fmax = 1234;
    xzoom = 1;
    memset(yellow, 0, sizeof(float)*n);
    memset(cyan, 0, sizeof(float)*n);
    backgroundredrawneeded=true;
    background=NULL;
    tempbitmap=NULL;
	};

	wxSize DoGetBestSize() const;

	void SetLevel(float *l,float *r);
  void SetMinMax(float dbmi,float dbma, float fmi, float fma, float xz=1);

private:
  wxBitmap     *tempbitmap;     // temporary bitmap so we can avoid using wxBufferedPaintDC(.)
  wxBitmap     *background;     // the (rarely changing) background, namely the scale etc.
  wxMemoryDC   dc_background;
  bool backgroundredrawneeded;

	int db2pix(float db);
	float yellow[1024];
	float cyan[1024];
	float dbmin;
	float dbmax;
        int n;
        float fmin,fmax;
        int height,width;
        float xzoom;
        wxString xfmt, xfmtk;

	// Event handlers
	void OnPaint(wxPaintEvent& event);
	void OnEraseBackGround(wxEraseEvent& event);
        void OnSize(wxSizeEvent& event);

};

#endif

